//algo.h
#include "graphe.h"
//heuristiques
//heuristique du moindre cout
tArretes * PVC_HMoindreCout(EuclidianGraphe *e,unsigned long options);
tArretes * PVC_HPlusProcheVoisin(EuclidianGraphe *e,unsigned long options);
tArretes * PVC_H2Opt(EuclidianGraphe *e,unsigned long options);
//options
#define O_DRAWMASK 0xffff
#define OPTION_DRAW(o) ((bool)(o&O_DRAWMASK))
#define OPTION_DRAWWAIT(o) (o&O_DRAWMASK)
#define O_OUTPUTMASK 0xff0000
#define OPTION_OUTPUT(o) ((o&O_OUTPUTMASK)>>16)
#define OPTION_SPEC(o) (o>>24)
enum OutputLevel
  {
    None=0,
    Important,
    Detailed,
    UltraDetailed,
    Verbose,
    Debug
  };

typedef tArretes * (*fExec)(EuclidianGraphe *e, unsigned long options);
struct PVC_Algo
{
  char *Name;
  char * Description;
  fExec Execute;
};
extern PVC_Algo  Algorithmes[];
