#include <semaphore.h>
struct synchronizer
{
  sem_t internal;
  sem_t sigwait;
  unsigned long sigwaiters;
  sem_t waitwait; 
  unsigned long waitwaitcount;
};

//cree un nouvel objet
synchronizer * synchronizer_new();
//bloque jusqu'a ce que la fonction signal soit appelee
void synchronizer_waitforsignal(synchronizer * sync);
//envoi le signal
void synchronizer_signal(synchronizer * sync);
//bloque jusq'a ce que waiterslimit thread attendent le signal (un seul appel a la fois)
bool synchronizer_waitforwaiters(synchronizer * sync,unsigned long waiterslimit);
void synchronizer_destroy(synchronizer * sync);
