//---------------------------------------------------------------------------

#include <stdlib.h>
#include <string.h>
#include "xtree.h"
//for further explanations,complete documentation and exemples on
//how to use this code,go to hell.
//---------------------------------------------------------------------------
xTree::xTree()
    {
      Next=Prev=Child=Parent=0;
    }
xTree::~xTree()
    {
    Remove();
    }
void xTree::Remove()
    {
    if (Prev) Prev->Next=Next;
    if (Next) Next->Prev=Prev;
    if (this==Parent->Child)
        {
        Parent->Child=Next;
        }
    }
void xTree::AddChild(xTree * child)
    {
    if (!Child) {Child=child;child->Parent=this;return;}
    xTree * lb=Child->LastBrother();
    lb->Next=child;
    child->Parent=this;
    child->Prev=lb;
    }
void xTree::AddBrother(xTree* br)
    {
    xTree * lb=LastBrother();
    lb->Next=br;
    br->Parent=Parent;
    br->Prev=lb;
    }
void xTree::rDelete()
    {
    for (xTree * tr=Child;tr ;tr=tr->Next)
        {
        tr->rDelete();
        }
    delete this;
    }
xTree * xTree::LastBrother()
    {
    xTree * lb=this;
    while (lb->Next) lb=lb->Next;
    return lb;
    }
DWORD xTree::Count()
    {
    return SumResults<xTree>(this,0,0);
    }


