//---------------------------------------------------------------------------
#ifndef xTreeH
#define xTreeH
//---------------------------------------------------------------------------
//classe  ecrite initialement pour windows
typedef unsigned long DWORD;
#ifndef _TDATA_
    #define _TDATA_
struct TData
    {
    unsigned long Size;
    void * Data;
    };
#endif
//Tree class,with save/load to/from buffer functions,by bearclaw
//for further explanations,complete documentation and exemples on
//how to use this code,go to hell.
class xTree
    {
    public:
    xTree * Parent;
    xTree * Child; //child must be the root of the chidren lc (ie Child->Prev must be NULL)
    xTree * Next; //next brother
    xTree * Prev;
    xTree();
    ~xTree();
    DWORD Count(); //count from this level
    void Remove(); //children get removed to
    void InsertAsParent(xTree *); //current Parent moved up
    void AddChild(xTree *);  //may have children/brothers,but must be root for both lc
    void AddBrother(xTree *); //idem
    void rDelete(); //recursive deletion of children,then itself
    xTree * LastBrother();
    DWORD Data(DWORD,void *) {return 1;}
    };
#define DAT_REDIR  0xff0000 //redir getdatato loadsaveop
#define OP_GETSIZE 1 //just return size
#define OP_WRITEDATA 2 //write data in addr given by the void ** and inc the void * and modify pointers
#define OP_DELTADATA 3  //add to  data addr the value given
//next one may be used for simply recursive call
//template<class TR> DWORD SumResults(TR * Root,DWORD (TR::*)(DWORD Param,void * Data),DWORD Param,void * Data );
//template<class TR> TData * Save(TR * Root);
//template<class TR> TR * Load(TData *);
//template<class TR> TR * Find(TR * Root,void * data,DWORD Param);
#include "xtree.hpp"
#endif
